; DriveWait v0.1 by Mark Jones 2006 (gzscuqn02 AT sneakemail D0T com)
; Waits 16 seconds for drive to respond or displays error message.
; Returns errorlevel 0 for success and 1 for failure.

include masm32rt.inc                    ; standard compile-time libs

.const
    szMutex         db  "Global\DWv0.1",0,0,0   ; instance marker
    szDW            db  "DriveWait v0.1",0,0    ; dialog text
    szNotFound      db  " drive not found!",0,0,0 
    szFound         db  ", drive located.",0,0,0,0 
    szCRLF          db  13,10,0
    szDot           db  ".",0
.data?
    hFolder         dd  ?               ; handle to drive
    hMutex          dd  ?               ; handle to instance
    szTemp          db 128 dup(?)       ; command argument buffer
    nCount          db  ?               ; byte used to retry drive 16 times
    nErrLvl         db  ?               ; byte used to convey errorlevel
.data
    szDest          db  "X:\",0         ; default removable drive
    szPowerUpDrive  db  "Please connect drive ", 7 dup (0)
    szWaiting       db  " Waiting for drive ",0,0,0,0,0

.code
start:
    invoke CreateMutex,0,1,addr szMutex ; only allow one instance
    mov hMutex,eax
    .if eax != NULL && FUNC( GetLastError ) == ERROR_ALREADY_EXISTS
err:    invoke Beep,100,1000            ; error sound
        invoke ExitProcess,1            ; exit with error!
    .endif

    invoke ArgClC,1,addr szTemp         ; get first command-line argument
    cmp byte ptr [szTemp],00            ; if no value was returned,
    jz err                              ; exit!
    mov al,byte ptr [szTemp]            ; else fetch letter
    mov byte ptr [szDest],al            ; and put it in szDest

hello:
    mov eax,dword ptr [szDest]          ; fetch drive letter into eax
    mov dword ptr [szPowerUpDrive+21],eax   ; copy text to other strings
    mov dword ptr [szWaiting+19],eax 
    invoke StdOut,addr szWaiting        ; echo waiting message to console

retry:
    invoke CreateFile,addr szDest,\     ; try opening destination drive
                      FILE_LIST_DIRECTORY,\
                      FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,\
                      NULL,\
                      OPEN_EXISTING,\
                      FILE_FLAG_BACKUP_SEMANTICS,\
                      NULL
    mov hFolder,eax                     ; save "folder" handle
    .if FUNC(GetLastError) == ERROR_PATH_NOT_FOUND
        invoke StdOut,addr szDot        ; add a "." to display
        invoke CloseHandle,hFolder      ; close file handle
        invoke Sleep,1000               ; wait 1 second
        sub nCount,16                   ; decrease counter by 16
        jnz retry                       ; repeat 16 times
        invoke MessageBox,0,addr szPowerUpDrive,addr szDW,\
                          MB_RETRYCANCEL+MB_SYSTEMMODAL
        .if eax==IDCANCEL
            invoke StdOut,addr szNotFound
            mov nErrLvl,1
            jmp endit                   ; exit
        .else
            jmp retry                   ; try again
        .endif
    .else
        invoke StdOut,addr szFound      ; drive woke up
    .endif
endit:
    invoke StdOut,addr szCRLF           ; CR+LF
    invoke CloseHandle,hFolder          ; close file handle
    invoke CloseHandle,hMutex           ; close mutex handle
    invoke ExitProcess,nErrLvl          ; exit gracefully with errorlevel
end start
